## blupimania 1.6.2-17-g5f6cf8b

=== debian/changelog ===
blupimania (1.6.2-17-g5f6cf8b-1) unstable; urgency=medium

  * Update to latest upstream snapshot 1.6.2-17-g5f6cf8b

 -- Didier Raboud <odyx@debian.org>  Sun, 07 Jan 2024 11:13:40 +0100

blupimania (1.6.2-15-g8f23b7a-1) unstable; urgency=medium

  * Update to latest upstream snapshot 1.6.2-15-g8f23b7a
    - Install CREDITS file in docs
  * d/copyright: Add argtable3 missing ©-holders

 -- Didier Raboud <odyx@debian.org>  Sun, 31 Dec 2023 11:28:02 +0100

blupimania (1.6.2-11-gee793c0-1) unstable; urgency=medium

  * Initial release (Closes: #1058699)
    - Based off a git snapshot, as it includes multiple fixes proposed
      to fit a Debian upload

 -- Didier Raboud <odyx@debian.org>  Wed, 20 Dec 2023 10:20:36 +0100
