=== debian/control ===
Source: blupimania
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Didier Raboud <odyx@debian.org>,
Section: games
Priority: optional
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libsdl2-dev,
 libsdl2-image-dev,
 libsdl2-mixer-dev,
 libwebp-dev,
 pkg-config,
 ronn,
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/games-team/blupimania
Vcs-Git: https://salsa.debian.org/games-team/blupimania.git
Homepage: https://blupi.org
Rules-Requires-Root: no

Package: blupimania
Architecture: any
Depends:
 blupimania-common (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: A mind boggling (brain twisting) game of logic
 Blupi comes out of a hole holding on to a balloon. Unfortunately he
 let's it blow away. Blupi is lost, he turns to the left or the right
 and does various unpredictable things of his own. The object of the
 game is to help him find another balloon, so that he can move on to the
 next riddle.

Package: blupimania-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 blupimania (>= ${source:Version}),
Enhances:
 blupimania,
Description: A mind boggling (brain twisting) game of logic - data
 Blupi comes out of a hole holding on to a balloon. Unfortunately he
 let's it blow away. Blupi is lost, he turns to the left or the right
 and does various unpredictable things of his own. The object of the
 game is to help him find another balloon, so that he can move on to the
 next riddle.
 .
 This package contains the architecture-independent game data.
