## blupimania 1.6.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 project (blupimania)
 set (BM_VERSION_MAJOR 1)
 set (BM_VERSION_MINOR 6)
-set (BM_VERSION_PATCH 2)
+set (BM_VERSION_PATCH 3)
 set (BM_VERSION_EXTRA "")
 set (BM_PRODUCT_NAME "Blupimania")
 set (BM_PACKAGE_NAME "blupimania")
