=== debian/changelog ===
blupimania (1.6.3-2) unstable; urgency=medium

  * Team Upload
  * Add d/gbp.conf

  [ Patrice Duroux ]
  * d/patches: add CMakeLists_txt.patch (Closes: #1096237)

 -- Alexandre Detiste <tchet@debian.org>  Fri, 07 Mar 2025 15:30:06 +0100

blupimania (1.6.3-1) unstable; urgency=medium

  * New 1.6.3 upstream release  
  * Bump S-V to 4.7 without changes needed
  * B-D: Replace pkg-config by pkgconf
  * d/copyright: Add missing appdata license
  * d/control: drop article at the start of short description

 -- Didier Raboud <odyx@debian.org>  Fri, 26 Apr 2024 15:16:02 +0200
