=== debian/control ===
--- 
+++ 
@@ -5,19 +5,20 @@
 Section: games
 Priority: optional
 Build-Depends:
+ debhelper-compat (= 13),
  cmake,
- debhelper-compat (= 13),
  libsdl2-dev,
  libsdl2-image-dev,
  libsdl2-mixer-dev,
  libwebp-dev,
- pkg-config,
+ pkgconf,
  ronn,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/games-team/blupimania
 Vcs-Git: https://salsa.debian.org/games-team/blupimania.git
 Homepage: https://blupi.org
 Rules-Requires-Root: no
+X-Style: black
 
 Package: blupimania
 Architecture: any
@@ -25,7 +26,7 @@
  blupimania-common (>= ${source:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
-Description: A mind boggling (brain twisting) game of logic
+Description: Mind boggling (brain twisting) game of logic
  Blupi comes out of a hole holding on to a balloon. Unfortunately he
  let's it blow away. Blupi is lost, he turns to the left or the right
  and does various unpredictable things of his own. The object of the
@@ -41,7 +42,7 @@
  blupimania (>= ${source:Version}),
 Enhances:
  blupimania,
-Description: A mind boggling (brain twisting) game of logic - data
+Description: Mind boggling (brain twisting) game of logic - data
  Blupi comes out of a hole holding on to a balloon. Unfortunately he
  let's it blow away. Blupi is lost, he turns to the left or the right
  and does various unpredictable things of his own. The object of the
